diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/pix5.c leptonlib-1.066/src/pix5.c
--- leptonlib-1.66/src/pix5.c	2010-07-20 00:01:57.000000000 +0300
+++ leptonlib-1.066/src/pix5.c	2010-09-15 09:43:51.000000000 +0300
@@ -1846,3 +1458,504 @@
     return 1;  /* edge not found */
 }
 
+
+/*---------------------------------------------------------------------*
+ *           Extract pixel averages and reversals along lines          *
+ *---------------------------------------------------------------------*/
+/*!
+ *  pixExtractOnLine()
+ *
+ *      Input:  pixs (1 bpp or 8 bpp; no colormap)
+ *              x1, y1 (starting pt for line)
+ *              x2, y2 (end pt for line)
+ *              factor (sampling; >= 1)
+ *      Return: na (of pixel values along line), or null on error.
+ *
+ *  Notes:
+ *      (1) The line must be either horizontal or vertical, so either
+ *          y1 == y2 (horizontal) or x1 == x2 (vertical).
+ *      (2) If horizontal, x1 must be <= x2.
+ *          If vertical, y1 must be <= y2.
+ *      (3) Input end points are clipped to the pix.
+ *      (4) Can be used with numaCountReverals(), for example, to
+ *          characterize the intensity smoothness along a line.
+ */
+NUMA *
+pixExtractOnLine(PIX     *pixs,
+                 l_int32  x1,
+                 l_int32  y1,
+                 l_int32  x2,
+                 l_int32  y2,
+                 l_int32  factor)
+{
+l_int32   i, w, h, d, direction;
+l_uint32  val;
+NUMA     *na;
+
+    PROCNAME("pixExtractOnLine");
+
+    if (!pixs)
+        return (NUMA *)ERROR_PTR("pixs not defined", procName, NULL);
+    pixGetDimensions(pixs, &w, &h, &d);
+    if (d != 1 && d != 8)
+        return (NUMA *)ERROR_PTR("d not 1 or 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (NUMA *)ERROR_PTR("pixs has a colormap", procName, NULL);
+    if (x1 > x2 || y1 > y2)
+        return (NUMA *)ERROR_PTR("x1 > x2 or y1 > y2", procName, NULL);
+    if (y1 == y2) {
+        x1 = L_MAX(0, x1);
+        x2 = L_MIN(w - 1, x2);
+        y1 = L_MAX(0, L_MIN(y1, h - 1));
+        direction = L_HORIZONTAL_LINE;
+    }
+    else if (x1 == x2) {
+        y1 = L_MAX(0, y1);
+        y2 = L_MIN(h - 1, y2);
+        x1 = L_MAX(0, L_MIN(x1, w - 1));
+        direction = L_VERTICAL_LINE;
+    }
+    if (y1 == y2)
+        direction = L_HORIZONTAL_LINE;
+    else if (x1 == x2)
+        direction = L_VERTICAL_LINE;
+    else
+        return (NUMA *)ERROR_PTR("line neither horiz nor vert", procName, NULL);
+    if (factor < 1) {
+        L_WARNING("factor must be >= 1; setting to 1", procName);
+        factor = 1;
+    }
+
+    na = numaCreate(0);
+    if (direction == L_HORIZONTAL_LINE) {
+        numaSetXParameters(na, x1, factor);
+        for (i = x1; i <= x2; i += factor) {
+            pixGetPixel(pixs, i, y1, &val);
+            numaAddNumber(na, val);
+        }
+    } else if (direction == L_VERTICAL_LINE) {
+        numaSetXParameters(na, y1, factor);
+        for (i = y1; i <= y2; i += factor) {
+            pixGetPixel(pixs, x1, i, &val);
+            numaAddNumber(na, val);
+        }
+    }
+
+    return na;
+}
+
+
+/*!
+ *  pixAverageOnLine()
+ *
+ *      Input:  pixs (1 bpp or 8 bpp; no colormap)
+ *              x1, y1 (starting pt for line)
+ *              x2, y2 (end pt for line)
+ *              factor (sampling; >= 1)
+ *      Return: average of pixel values along line, or null on error.
+ *
+ *  Notes:
+ *      (1) The line must be either horizontal or vertical, so either
+ *          y1 == y2 (horizontal) or x1 == x2 (vertical).
+ *      (2) If horizontal, x1 must be <= x2.
+ *          If vertical, y1 must be <= y2.
+ *          characterize the intensity smoothness along a line.
+ *      (3) Input end points are clipped to the pix.
+ */
+l_float32
+pixAverageOnLine(PIX     *pixs,
+                 l_int32  x1,
+                 l_int32  y1,
+                 l_int32  x2,
+                 l_int32  y2,
+                 l_int32  factor)
+{
+l_int32    i, j, w, h, d, direction, count, wpl;
+l_uint32  *data, *line;
+l_float32  sum;
+
+    PROCNAME("pixAverageOnLine");
+
+    if (!pixs)
+        return ERROR_INT("pixs not defined", procName, 1);
+    pixGetDimensions(pixs, &w, &h, &d);
+    if (d != 1 && d != 8)
+        return ERROR_INT("d not 1 or 8 bpp", procName, 1);
+    if (pixGetColormap(pixs))
+        return ERROR_INT("pixs has a colormap", procName, 1);
+    if (x1 > x2 || y1 > y2)
+        return ERROR_INT("x1 > x2 or y1 > y2", procName, 1);
+    if (y1 == y2) {
+        x1 = L_MAX(0, x1);
+        x2 = L_MIN(w - 1, x2);
+        y1 = L_MAX(0, L_MIN(y1, h - 1));
+        direction = L_HORIZONTAL_LINE;
+    }
+    else if (x1 == x2) {
+        y1 = L_MAX(0, y1);
+        y2 = L_MIN(h - 1, y2);
+        x1 = L_MAX(0, L_MIN(x1, w - 1));
+        direction = L_VERTICAL_LINE;
+    }
+    else
+        return ERROR_INT("line neither horiz nor vert", procName, 1);
+    if (factor < 1) {
+        L_WARNING("factor must be >= 1; setting to 1", procName);
+        factor = 1;
+    }
+
+    data = pixGetData(pixs);
+    wpl = pixGetWpl(pixs);
+    sum = 0;
+    if (direction == L_HORIZONTAL_LINE) {
+        line = data + y1 * wpl;
+        for (j = x1, count = 0; j <= x2; count++, j += factor) {
+            if (d == 1)
+                sum += GET_DATA_BIT(line, j);
+            else  /* d == 8 */
+                sum += GET_DATA_BYTE(line, j);
+        }
+    }
+    else if (direction == L_VERTICAL_LINE) {
+        for (i = y1, count = 0; i <= y2; count++, i += factor) {
+            line = data + i * wpl;
+            if (d == 1)
+                sum += GET_DATA_BIT(line, x1);
+            else  /* d == 8 */
+                sum += GET_DATA_BYTE(line, x1);
+        }
+    }
+
+    return sum / (l_float32)count;
+}
+
+
+/*!
+ *  pixAverageIntensityProfile()
+ *
+ *      Input:  pixs (any depth; colormap OK)
+ *              fract (fraction of image width or height to be used)
+ *              dir (averaging direction: L_HORIZONTAL_LINE or L_VERTICAL_LINE)
+ *              first, last (span of rows or columns to measure)
+ *              factor1 (sampling along fast scan direction; >= 1)
+ *              factor2 (sampling along slow scan direction; >= 1)
+ *      Return: na (of reversal profile), or null on error.
+ *
+ *  Notes:
+ *      (1) If d != 1 bpp, colormaps are removed and the result
+ *          is converted to 8 bpp.
+ *      (2) If @dir == L_HORIZONTAL_LINE, the intensity is averaged
+ *          along each horizontal raster line (sampled by @factor1),
+ *          and the profile is the array of these averages in the
+ *          vertical direction between @first and @last raster lines,
+ *          and sampled by @factor2.
+ *      (3) If @dir == L_VERTICAL_LINE, the intensity is averaged
+ *          along each vertical line (sampled by @factor1),
+ *          and the profile is the array of these averages in the
+ *          horizontal direction between @first and @last columns,
+ *          and sampled by @factor2.
+ *      (4) The averages are measured over the central @fract of the image.
+ *          Use @fract == 1.0 to average across the entire width or height.
+ */
+NUMA *
+pixAverageIntensityProfile(PIX       *pixs,
+                           l_float32  fract,
+                           l_int32    dir,
+                           l_int32    first,
+                           l_int32    last,
+                           l_int32    factor1,
+                           l_int32    factor2)
+{
+l_int32    i, j, w, h, d, start, end;
+l_float32  ave;
+NUMA      *nad;
+PIX       *pixr, *pixg;
+
+    PROCNAME("pixAverageIntensityProfile");
+
+    if (!pixs)
+        return (NUMA *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (fract < 0.0 || fract > 1.0)
+        return (NUMA *)ERROR_PTR("fract < 0.0 or > 1.0", procName, NULL);
+    if (dir != L_HORIZONTAL_LINE && dir != L_VERTICAL_LINE)
+        return (NUMA *)ERROR_PTR("invalid direction", procName, NULL);
+    if (first < 0) first = 0;
+    if (last < first)
+        return (NUMA *)ERROR_PTR("last must be >= first", procName, NULL);
+    if (factor1 < 1) {
+        L_WARNING("factor1 must be >= 1; setting to 1", procName);
+        factor1 = 1;
+    }
+    if (factor2 < 1) {
+        L_WARNING("factor2 must be >= 1; setting to 1", procName);
+        factor2 = 1;
+    }
+
+        /* Use 1 or 8 bpp, without colormap */
+    if (pixGetColormap(pixs))
+        pixr = pixRemoveColormap(pixs, REMOVE_CMAP_TO_GRAYSCALE);
+    else
+        pixr = pixClone(pixs);
+    pixGetDimensions(pixr, &w, &h, &d);
+    if (d == 1)
+        pixg = pixClone(pixr);
+    else
+        pixg = pixConvertTo8(pixr, 0);
+
+    nad = numaCreate(0);  /* output: samples in slow scan direction */
+    numaSetXParameters(nad, 0, factor2);
+    if (dir == L_HORIZONTAL_LINE) {
+        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)w);
+        end = w - start;
+        if (last > h - 1) {
+            L_WARNING("last > h - 1; clipping", procName);
+            last = h - 1;
+        }
+        for (i = first; i <= last; i += factor2) {
+            ave = pixAverageOnLine(pixg, start, i, end, i, factor1);
+            numaAddNumber(nad, ave);
+        }
+    } else if (dir == L_VERTICAL_LINE) {
+        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)h);
+        end = h - start;
+        if (last > w - 1) {
+            L_WARNING("last > w - 1; clipping", procName);
+            last = w - 1;
+        }
+        for (j = first; j <= last; j += factor2) {
+            ave = pixAverageOnLine(pixg, j, start, j, end, factor1);
+            numaAddNumber(nad, ave);
+        }
+    }
+
+    pixDestroy(&pixr);
+    pixDestroy(&pixg);
+    return nad;
+}
+
+
+/*!
+ *  pixReversalProfile()
+ *
+ *      Input:  pixs (any depth; colormap OK)
+ *              fract (fraction of image width or height to be used)
+ *              dir (profile direction: L_HORIZONTAL_LINE or L_VERTICAL_LINE)
+ *              first, last (span of rows or columns to measure)
+ *              minreversal (minimum change in intensity to trigger a reversal)
+ *              factor1 (sampling along raster line (fast scan); >= 1)
+ *              factor2 (sampling of raster lines (slow scan); >= 1)
+ *      Return: na (of reversal profile), or null on error.
+ *
+ *  Notes:
+ *      (1) If d != 1 bpp, colormaps are removed and the result
+ *          is converted to 8 bpp.
+ *      (2) If @dir == L_HORIZONTAL_LINE, the the reversals are counted
+ *          along each horizontal raster line (sampled by @factor1),
+ *          and the profile is the array of these sums in the
+ *          vertical direction between @first and @last raster lines,
+ *          and sampled by @factor2.
+ *      (3) If @dir == L_VERTICAL_LINE, the the reversals are counted
+ *          along each vertical column (sampled by @factor1),
+ *          and the profile is the array of these sums in the
+ *          horizontal direction between @first and @last columns,
+ *          and sampled by @factor2.
+ *      (4) For each row or column, the reversals are summed over the
+ *          central @fract of the image.  Use @fract == 1.0 to sum
+ *          across the entire width (of row) or height (of column).
+ *      (5) @minreversal is the relative change in intensity that is
+ *          required to resolve peaks and valleys.  A typical number for
+ *          locating text in 8 bpp might be 50.  For 1 bpp, minreversal
+ *          must be 1.
+ *      (6) The reversal profile is simply the number of reversals
+ *          in a row or column, vs the row or column index.
+ */
+NUMA *
+pixReversalProfile(PIX       *pixs,
+                   l_float32  fract,
+                   l_int32    dir,
+                   l_int32    first,
+                   l_int32    last,
+                   l_int32    minreversal,
+                   l_int32    factor1,
+                   l_int32    factor2)
+{
+l_int32   i, j, w, h, d, start, end, nr;
+NUMA     *naline, *nad;
+PIX      *pixr, *pixg;
+
+    PROCNAME("pixReversalProfile");
+
+    if (!pixs)
+        return (NUMA *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (fract < 0.0 || fract > 1.0)
+        return (NUMA *)ERROR_PTR("fract < 0.0 or > 1.0", procName, NULL);
+    if (dir != L_HORIZONTAL_LINE && dir != L_VERTICAL_LINE)
+        return (NUMA *)ERROR_PTR("invalid direction", procName, NULL);
+    if (first < 0) first = 0;
+    if (last < first)
+        return (NUMA *)ERROR_PTR("last must be >= first", procName, NULL);
+    if (factor1 < 1) {
+        L_WARNING("factor1 must be >= 1; setting to 1", procName);
+        factor1 = 1;
+    }
+    if (factor2 < 1) {
+        L_WARNING("factor2 must be >= 1; setting to 1", procName);
+        factor2 = 1;
+    }
+
+        /* Use 1 or 8 bpp, without colormap */
+    if (pixGetColormap(pixs))
+        pixr = pixRemoveColormap(pixs, REMOVE_CMAP_TO_GRAYSCALE);
+    else
+        pixr = pixClone(pixs);
+    pixGetDimensions(pixr, &w, &h, &d);
+    if (d == 1) {
+        pixg = pixClone(pixr);
+        minreversal = 1;  /* enforce this */
+    }
+    else
+        pixg = pixConvertTo8(pixr, 0);
+
+    nad = numaCreate(0);  /* output: samples in slow scan direction */
+    numaSetXParameters(nad, 0, factor2);
+    if (dir == L_HORIZONTAL_LINE) {
+        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)w);
+        end = w - start;
+        if (last > h - 1) {
+            L_WARNING("last > h - 1; clipping", procName);
+            last = h - 1;
+        }
+        for (i = first; i <= last; i += factor2) {
+            naline = pixExtractOnLine(pixg, start, i, end, i, factor1);
+            numaCountReversals(naline, minreversal, &nr, NULL);
+            numaAddNumber(nad, nr);
+            numaDestroy(&naline);
+        }
+    } else if (dir == L_VERTICAL_LINE) {
+        start = (l_int32)(0.5 * (1.0 - fract) * (l_float32)h);
+        end = h - start;
+        if (last > w - 1) {
+            L_WARNING("last > w - 1; clipping", procName);
+            last = w - 1;
+        }
+        for (j = first; j <= last; j += factor2) {
+            naline = pixExtractOnLine(pixg, j, start, j, end, factor1);
+            numaCountReversals(naline, minreversal, &nr, NULL);
+            numaAddNumber(nad, nr);
+            numaDestroy(&naline);
+        }
+    }
+
+    pixDestroy(&pixr);
+    pixDestroy(&pixg);
+    return nad;
+}
+
+
+/*---------------------------------------------------------------------*
+ *                     Rank row and column transforms                  *
+ *---------------------------------------------------------------------*/
+/*!
+ *  pixRankRowTransform()
+ *
+ *      Input:  pixs (8 bpp; no colormap)
+ *      Return: pixd (with pixels sorted in each row, from
+ *                    min to max value)
+ *
+ * Notes:
+ *     (1) The time is O(n) in the number of pixels and runs about
+ *         100 Mpixels/sec on a 3 GHz machine.
+ */
+PIX *
+pixRankRowTransform(PIX  *pixs)
+{
+l_int32    i, j, k, m, w, h, wpl, index, val; 
+l_int32    histo[256];
+l_uint32  *datas, *datad, *lines, *lined;
+PIX       *pixd;
+
+    PROCNAME("pixRankRowTransform");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (PIX *)ERROR_PTR("pixs has a colormap", procName, NULL);
+
+    pixGetDimensions(pixs, &w, &h, NULL);
+    pixd = pixCreateTemplateNoInit(pixs);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    wpl = pixGetWpl(pixs);
+    for (i = 0; i < h; i++) {
+        memset(histo, 0, 1024);
+        lines = datas + i * wpl;
+        lined = datad + i * wpl;
+        for (j = 0; j < w; j++) {
+            val = GET_DATA_BYTE(lines, j);
+            histo[val]++;
+        }
+        for (m = 0, j = 0; m < 256; m++) {
+            for (k = 0; k < histo[m]; k++, j++)
+                SET_DATA_BYTE(lined, j, m);
+        }
+    }
+
+    return pixd;
+}
+
+
+/*!
+ *  pixRankColumnTransform()
+ *
+ *      Input:  pixs (8 bpp; no colormap)
+ *      Return: pixd (with pixels sorted in each column, from
+ *                    min to max value)
+ *
+ * Notes:
+ *     (1) The time is O(n) in the number of pixels and runs about
+ *         50 Mpixels/sec on a 3 GHz machine.
+ */
+PIX *
+pixRankColumnTransform(PIX  *pixs)
+{
+l_int32    i, j, k, m, w, h, wpl, val; 
+l_int32    histo[256];
+l_uint32  *datas, *datad;
+void     **lines8, **lined8;
+PIX       *pixd;
+
+    PROCNAME("pixRankColumnTransform");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (PIX *)ERROR_PTR("pixs has a colormap", procName, NULL);
+
+    pixGetDimensions(pixs, &w, &h, NULL);
+    pixd = pixCreateTemplateNoInit(pixs);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    wpl = pixGetWpl(pixs);
+    lines8 = pixGetLinePtrs(pixs, NULL);
+    lined8 = pixGetLinePtrs(pixd, NULL);
+    for (j = 0; j < w; j++) {
+        memset(histo, 0, 1024);
+        for (i = 0; i < h; i++) {
+            val = GET_DATA_BYTE(lines8[i], j);
+            histo[val]++;
+        }
+        for (m = 0, i = 0; m < 256; m++) {
+            for (k = 0; k < histo[m]; k++, i++)
+                SET_DATA_BYTE(lined8[i], j, m);
+        }
+    }
+
+    FREE(lines8);
+    FREE(lined8);
+    return pixd;
+}
+
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/pixcomp.c leptonlib-1.066/src/pixcomp.c
--- leptonlib-1.66/src/pixcomp.c	2010-03-24 18:13:02.000000000 +0200
+++ leptonlib-1.066/src/pixcomp.c	2010-09-15 22:36:50.000000000 +0300
@@ -1261,7 +1261,8 @@
             return (PIXAC *)ERROR_PTR("res reading", procName, NULL);
         if ((data = (l_uint8 *)CALLOC(1, size)) == NULL)
             return (PIXAC *)ERROR_PTR("calloc fail for data", procName, NULL);
-        fread(data, size, 1, fp);
+        if (fread(data, 1, size, fp) != size)
+            return (PIXAC *)ERROR_PTR("error reading data", procName, NULL);
         pixc->w = w;
         pixc->h = h;
         pixc->d = d;
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/pngio.c leptonlib-1.066/src/pngio.c
--- leptonlib-1.66/src/pngio.c	2010-05-05 20:56:47.000000000 +0300
+++ leptonlib-1.066/src/pngio.c	2010-09-16 08:16:17.000000000 +0300
@@ -405,7 +405,8 @@
         return ERROR_INT("file too small to be png", procName, 1);
     if ((data = (l_uint8 *)CALLOC(40, sizeof(l_uint8))) == NULL)
         return ERROR_INT("CALLOC fail for data", procName, 1);
-    fread(data, 40, 1, fp);
+    if (fread(data, 1, 40, fp) != 40)
+        return ERROR_INT("error reading data", procName, 1);
     ret = sreadHeaderPng(data, pwidth, pheight, pbps, pspp, piscmap);
     FREE(data);
     return ret;
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/pnmio.c leptonlib-1.066/src/pnmio.c
--- leptonlib-1.66/src/pnmio.c	2009-11-22 03:37:39.000000000 +0200
+++ leptonlib-1.066/src/pnmio.c	2010-09-15 22:36:39.000000000 +0300
@@ -98,7 +98,7 @@
 {
 l_uint8    val8, rval8, gval8, bval8;
 l_uint16   val16;
-l_int32    w, h, d, bpl, wpl, i, j, type;
+l_int32    w, h, d, bpl, wpl, i, j, type, ignore;
 l_int32    val, rval, gval, bval;
 l_uint32   rgbval;
 l_uint32  *line, *data;
@@ -144,7 +144,8 @@
         for (i = 0; i < h; i++) {
             line = data + i * wpl;
             for (j = 0; j < bpl; j++) {
-                fread(&val8, 1, 1, fp);
+                if (fread(&val8, 1, 1, fp) != 1)
+                    return (PIX *)ERROR_PTR( "read error in 4", procName, pix);
                 SET_DATA_BYTE(line, j, val8);
             }
         }
@@ -158,7 +159,8 @@
             line = data + i * wpl;
             if (d != 16) {
                 for (j = 0; j < w; j++) {
-                    fread(&val8, 1, 1, fp);
+                    if (fread(&val8, 1, 1, fp) != 1)
+                        return (PIX *)ERROR_PTR( "error in 5", procName, pix);
                     if (d == 2)
                         SET_DATA_DIBIT(line, j, val8);
                     else if (d == 4)
@@ -169,7 +171,8 @@
             }
             else {  /* d == 16 */
                 for (j = 0; j < w; j++) {
-                    fread(&val16, 2, 1, fp);
+                    if (fread(&val16, 2, 1, fp) != 1)
+                        return (PIX *)ERROR_PTR( "16 bpp error", procName, pix);
                     SET_DATA_TWO_BYTES(line, j, val16);
                 }
             }
@@ -181,9 +184,12 @@
     for (i = 0; i < h; i++) {
         line = data + i * wpl;
         for (j = 0; j < wpl; j++) {
-            fread(&rval8, 1, 1, fp);
-            fread(&gval8, 1, 1, fp);
-            fread(&bval8, 1, 1, fp);
+            if (fread(&rval8, 1, 1, fp) != 1)
+                return (PIX *)ERROR_PTR( "read error type 6", procName, pix);
+            if (fread(&gval8, 1, 1, fp) != 1)
+                return (PIX *)ERROR_PTR( "read error type 6", procName, pix);
+            if (fread(&bval8, 1, 1, fp) != 1)
+                return (PIX *)ERROR_PTR( "read error type 6", procName, pix);
             composeRGBPixel(rval8, gval8, bval8, &rgbval);
             line[j] = rgbval;
         }
@@ -204,11 +210,6 @@
  *              &bps (<optional return>, bits/sample)
  *              &spp (<optional return>, samples/pixel)
  *      Return: 0 if OK, 1 on error
- *
- *  Notes:
- *      (1) To get only the header data, set @getpix == 0.
- *          However, if this is called as part of reading a pix from a file,
- *          set @getpix == 1 to return the pix without the image data.
  */
 l_int32
 freadHeaderPnm(FILE     *fp,
@@ -220,7 +221,7 @@
                l_int32  *pbps,
                l_int32  *pspp)
 {
-l_int32  w, h, d, type;
+l_int32  w, h, d, type, ignore;
 l_int32  maxval;
 
     PROCNAME("freadHeaderPnm");
@@ -230,14 +231,14 @@
     if (!pwidth || !pheight || !pdepth || !ptype)
         return ERROR_INT("input ptr(s) not defined", procName, 1);
 
-    fscanf(fp, "P%d\n", &type);
+    ignore = fscanf(fp, "P%d\n", &type);
     if (type < 1 || type > 6)
         return ERROR_INT("invalid pnm file", procName, 1);
 
     if (pnmSkipCommentLines(fp))
         return ERROR_INT("no data in file", procName, 1);
 
-    fscanf(fp, "%d %d\n", &w, &h);
+    ignore = fscanf(fp, "%d %d\n", &w, &h);
     if (w <= 0 || h <= 0 || w > MAX_PNM_WIDTH || h > MAX_PNM_HEIGHT)
         return ERROR_INT("invalid sizes", procName, 1);
 
@@ -245,7 +246,7 @@
     if (type == 1 || type == 4)
         d = 1;
     else if (type == 2 || type == 5) {
-        fscanf(fp, "%d\n", &maxval);
+        ignore = fscanf(fp, "%d\n", &maxval);
         if (maxval == 3)
             d = 2;
         else if (maxval == 15)
@@ -260,7 +261,7 @@
         }
     }
     else {  /* type == 3 || type == 6; this is rgb  */
-        fscanf(fp, "%d\n", &maxval);
+        ignore = fscanf(fp, "%d\n", &maxval);
         if (maxval != 255)
             L_WARNING_INT("unexpected maxval = %d", procName, maxval);
         d = 32;
@@ -275,7 +276,7 @@
     if (!ppix)
         return 0;
 
-    if ((*ppix = pixCreate(w, h, d)) == NULL)
+    if ((*ppix = pixCreate(w, h, d)) == NULL)  /* return pix initialized to 0 */
         return ERROR_INT( "pix not made", procName, 1);
     return 0;
 }
@@ -701,7 +702,7 @@
 pnmReadNextAsciiValue(FILE  *fp,
                       l_int32 *pval)
 {
-l_int32   c;
+l_int32   c, ignore;
 
     PROCNAME("pnmReadNextAsciiValue");
 
@@ -716,7 +717,7 @@
     } while (c == ' ' || c == '\t' || c == '\n' || c == '\r');
 
     fseek(fp, -1L, SEEK_CUR);        /* back up one byte */
-    fscanf(fp, "%d", pval);
+    ignore = fscanf(fp, "%d", pval);
     return 0;
 }
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/ptabasic.c leptonlib-1.066/src/ptabasic.c
--- leptonlib-1.66/src/ptabasic.c	2010-07-19 03:55:35.000000000 +0300
+++ leptonlib-1.066/src/ptabasic.c	2010-09-16 07:55:25.000000000 +0300
@@ -527,11 +527,13 @@
         return (PTA *)ERROR_PTR("pta not made", procName, NULL);
     for (i = 0; i < n; i++) {
         if (type == 0) {  /* data is float */
-            fscanf(fp, "   (%f, %f)\n", &x, &y);
+            if (fscanf(fp, "   (%f, %f)\n", &x, &y) != 2)
+                return (PTA *)ERROR_PTR("error reading floats", procName, NULL);
             ptaAddPt(pta, x, y);
         }
         else {   /* data is integer */
-            fscanf(fp, "   (%d, %d)\n", &ix, &iy);
+            if (fscanf(fp, "   (%d, %d)\n", &ix, &iy) != 2)
+                return (PTA *)ERROR_PTR("error reading ints", procName, NULL);
             ptaAddPt(pta, ix, iy);
         }
     }
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/regutils.c leptonlib-1.066/src/regutils.c
--- leptonlib-1.66/src/regutils.c	2010-08-02 08:35:07.000000000 +0300
+++ leptonlib-1.066/src/regutils.c	2010-09-10 23:33:08.000000000 +0300
@@ -577,22 +577,25 @@
 static char *
 getRootNameFromArgv0(const char  *argv0)
 {
-l_int32  len;
+l_int32  len, suffix_len;
 char    *root;
 
     PROCNAME("getRootNameFromArgv0");
 
 #ifdef _WIN32
-    if ((len = strlen(argv0)) < 9)
-        return (char *)ERROR_PTR("invalid argv0; too small", procName, NULL);
+    suffix_len = strlen("_reg.exe");
     splitPathAtDirectory(argv0, NULL, &root);
-    root[len - 8] = '\0';
+    if ((len = strlen(root)) <= suffix_len) {
+        FREE(root);
+        return (char *)ERROR_PTR("invalid argv0; too small", procName, NULL);
+    }
 #else
-    if ((len = strlen(argv0)) < 5)
+    suffix_len = strlen("_reg");
+    if ((len = strlen(argv0)) <= suffix_len)
         return (char *)ERROR_PTR("invalid argv0", procName, NULL);
     root = stringNew(argv0);
-    root[len - 4] = '\0';
 #endif  /*  _WIN32 */
+    root[len - suffix_len] = '\0';
     return root;
 }
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/sarray.c leptonlib-1.066/src/sarray.c
--- leptonlib-1.66/src/sarray.c	2010-08-07 00:15:12.000000000 +0300
+++ leptonlib-1.066/src/sarray.c	2010-09-16 08:11:10.000000000 +0300
@@ -1441,7 +1441,7 @@
 sarrayReadStream(FILE  *fp)
 {
 char    *stringbuf;
-l_int32  i, n, size, index, bufsize, ret, version;
+l_int32  i, n, size, index, bufsize, version, ignore;
 SARRAY  *sa;
 
     PROCNAME("sarrayReadStream");
@@ -1449,12 +1449,12 @@
     if (!fp)
         return (SARRAY *)ERROR_PTR("stream not defined", procName, NULL);
 
-    ret = fscanf(fp, "\nSarray Version %d\n", &version);
-    if (ret != 1)
+    if (fscanf(fp, "\nSarray Version %d\n", &version) != 1)
         return (SARRAY *)ERROR_PTR("not an sarray file", procName, NULL);
     if (version != SARRAY_VERSION_NUMBER)
         return (SARRAY *)ERROR_PTR("invalid sarray version", procName, NULL);
-    fscanf(fp, "Number of strings = %d\n", &n);
+    if (fscanf(fp, "Number of strings = %d\n", &n) != 1)
+        return (SARRAY *)ERROR_PTR("error on # strings", procName, NULL);
 
     if ((sa = sarrayCreate(n)) == NULL)
         return (SARRAY *)ERROR_PTR("sa not made", procName, NULL);
@@ -1464,7 +1464,8 @@
 
     for (i = 0; i < n; i++) {
 	    /* Get the size of the stored string */
-        fscanf(fp, "%d[%d]:", &index, &size);
+        if (fscanf(fp, "%d[%d]:", &index, &size) != 2)
+            return (SARRAY *)ERROR_PTR("error on string size", procName, NULL);
 	    /* Expand the string buffer if necessary */
 	if (size > bufsize - 5) {
             FREE(stringbuf);
@@ -1472,13 +1473,14 @@
             stringbuf = (char *)CALLOC(bufsize, sizeof(char));
 	}
 	    /* Read the stored string, plus leading spaces and trailing \n */
-	fread(stringbuf, 1, size + 3, fp);
+	if (fread(stringbuf, 1, size + 3, fp) != size + 3)
+            return (SARRAY *)ERROR_PTR("error reading string", procName, NULL);
 	    /* Remove the \n that was added by sarrayWriteStream() */
 	stringbuf[size + 2] = '\0';
 	    /* Copy it in, skipping the 2 leading spaces */
         sarrayAddString(sa, stringbuf + 2, L_COPY);
     }
-    fscanf(fp, "\n");
+    ignore = fscanf(fp, "\n");
 
     FREE(stringbuf);
     return sa;
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/sel1.c leptonlib-1.066/src/sel1.c
--- leptonlib-1.66/src/sel1.c	2010-06-07 20:41:54.000000000 +0300
+++ leptonlib-1.066/src/sel1.c	2010-09-16 08:20:01.000000000 +0300
@@ -1349,7 +1349,7 @@
 {
 char    *selname;
 char     linebuf[L_BUF_SIZE];
-l_int32  sy, sx, cy, cx, i, j, ret, version;
+l_int32  sy, sx, cy, cx, i, j, version, ignore;
 SEL     *sel;
 
     PROCNAME("selReadStream");
@@ -1357,13 +1357,13 @@
     if (!fp)
         return (SEL *)ERROR_PTR("stream not defined", procName, NULL);
 
-    ret = fscanf(fp, "  Sel Version %d\n", &version);
-    if (ret != 1)
+    if (fscanf(fp, "  Sel Version %d\n", &version) != 1)
         return (SEL *)ERROR_PTR("not a sel file", procName, NULL);
     if (version != SEL_VERSION_NUMBER)
         return (SEL *)ERROR_PTR("invalid sel version", procName, NULL);
 
-    fgets(linebuf, L_BUF_SIZE, fp);
+    if (fgets(linebuf, L_BUF_SIZE, fp) == NULL)
+        return (SEL *)ERROR_PTR("error reading into linebuf", procName, NULL);
     selname = stringNew(linebuf);
     sscanf(linebuf, "  ------  %s  ------", selname);
 
@@ -1376,12 +1376,12 @@
     selSetOrigin(sel, cy, cx);
 
     for (i = 0; i < sy; i++) {
-        fscanf(fp, "    ");
+        ignore = fscanf(fp, "    ");
         for (j = 0; j < sx; j++)
-            fscanf(fp, "%1d", &sel->data[i][j]);
-        fscanf(fp, "\n");
+            ignore = fscanf(fp, "%1d", &sel->data[i][j]);
+        ignore = fscanf(fp, "\n");
     }
-    fscanf(fp, "\n");
+    ignore = fscanf(fp, "\n");
 
     FREE(selname);
     return sel;
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/spixio.c leptonlib-1.066/src/spixio.c
--- leptonlib-1.66/src/spixio.c	2010-06-25 19:03:09.000000000 +0300
+++ leptonlib-1.066/src/spixio.c	2010-09-16 08:14:40.000000000 +0300
@@ -157,7 +157,8 @@
         return ERROR_INT("file too small to be spix", procName, 1);
     if ((data = (l_uint32 *)CALLOC(6, sizeof(l_uint32))) == NULL)
         return ERROR_INT("CALLOC fail for data", procName, 1);
-    fread(data, 6, 4, fp);
+    if (fread(data, 4, 6, fp) != 6)
+        return ERROR_INT("error reading data", procName, 1);
     ret = sreadHeaderSpix(data, pwidth, pheight, pbps, pspp, piscmap);
     FREE(data);
     return ret;
